﻿using System;
using System.Data;
using System.Linq;
using Wisej.Web;

namespace TreeView01
{
    public partial class Window1 : Form
    {
        DataTable dt = new DataTable();

        public Window1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            dt.Columns.Add("country_ref_no");
            dt.Columns.Add("country_name");
            dt.Columns.Add("state_ref_no");
            dt.Columns.Add("state_name");

            DataRow dr = dt.NewRow();
            dr["country_ref_no"] = "100";
            dr["country_name"] = "India";
            dr["state_ref_no"] = "100100";
            dr["state_name"] = "Tamil Nadu";

            dt.Rows.Add(dr);
            //
            dr = dt.NewRow();
            dr["country_ref_no"] = "100";
            dr["country_name"] = "India";
            dr["state_ref_no"] = "100101";
            dr["state_name"] = "Kerala";

            dt.Rows.Add(dr);
            //
            dr = dt.NewRow();
            dr["country_ref_no"] = "100";
            dr["country_name"] = "India";
            dr["state_ref_no"] = "100102";
            dr["state_name"] = "Karnataka";

            dt.Rows.Add(dr);
            //
            dr = dt.NewRow();
            dr["country_ref_no"] = "101";
            dr["country_name"] = "USA";
            dr["state_ref_no"] = "101103";
            dr["state_name"] = "Texas";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "101";
            dr["country_name"] = "USA";
            dr["state_ref_no"] = "101104";
            dr["state_name"] = "Florida";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "101";
            dr["country_name"] = "USA";
            dr["state_ref_no"] = "101105";
            dr["state_name"] = "Georgia";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "102";
            dr["country_name"] = "UAE";
            dr["state_ref_no"] = "102106";
            dr["state_name"] = "Dubai";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "102";
            dr["country_name"] = "UAE";
            dr["state_ref_no"] = "102107";
            dr["state_name"] = "Sharjah";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "102";
            dr["country_name"] = "UAE";
            dr["state_ref_no"] = "102108";
            dr["state_name"] = "Ajman";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "103";
            dr["country_name"] = "Germany";
            dr["state_ref_no"] = "103109";
            dr["state_name"] = "Bavaria";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "103";
            dr["country_name"] = "Germany";
            dr["state_ref_no"] = "103110";
            dr["state_name"] = "Hessen";

            dt.Rows.Add(dr);
            //

            dr = dt.NewRow();
            dr["country_ref_no"] = "103";
            dr["country_name"] = "Germany";
            dr["state_ref_no"] = "103111";
            dr["state_name"] = "Thuringia";

            dt.Rows.Add(dr);
            //

            MessageBox.Show("Data Table is created");





        }

        private void button2_Click(object sender, EventArgs e)
        {
            string strMsg = "";

            for (int i = 0; i < dt.Rows.Count; i++)
            {
                strMsg = "Country Code : " + dt.Rows[i]["country_ref_no"].ToString();
                strMsg = strMsg + "\nCountry Name : " + dt.Rows[i]["country_name"].ToString();
                strMsg = strMsg + "\n\nState Code : " + dt.Rows[i]["state_ref_no"].ToString();
                strMsg = strMsg + "\nState Name : " + dt.Rows[i]["state_name"].ToString();

                MessageBox.Show(strMsg);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            FunVoid_AddCountry();
        }

        private void FunVoid_AddCountry()
        {
            treeView1.Nodes.Clear();
            TreeNode nodRoot = new TreeNode();
            nodRoot.Name = "CountryState";
            nodRoot.Text = "Country and State";
            nodRoot.ForeColor = System.Drawing.Color.Red;
            treeView1.Nodes.Add(nodRoot);
            //
            string strCountryRefNo = ""; string strCountryName = ""; string strStateRefNo = ""; string strStateName = "";

            for (int i = 0; i < dt.Rows.Count; i++)
            {
                strCountryRefNo = ""; strCountryName = "";

                strCountryRefNo = dt.Rows[i]["country_ref_no"].ToString();
                strCountryName = dt.Rows[i]["country_name"].ToString();
                //
                strStateRefNo = dt.Rows[i]["state_ref_no"].ToString();
                strStateName = dt.Rows[i]["state_name"].ToString();
                //
                TreeNode[] nodFind;
                nodFind = treeView1.Nodes.Find(strCountryRefNo, true);
                if (nodFind == null || nodFind.Count() <= 0)
                {
                    TreeNode nodCountry = new TreeNode();
                    nodCountry.Name = strCountryRefNo;
                    nodCountry.Text = strCountryName + " - " + strCountryRefNo;
                    nodCountry.ForeColor = System.Drawing.Color.Blue;
                    treeView1.Nodes["CountryState"].Nodes.Add(nodCountry);
                    nodRoot.Nodes.Add(nodCountry);
                    //
                    FunVoid_TreeViewAddState(nodCountry, strStateRefNo, strStateName);
                }
                else
                {
                    FunVoid_TreeViewAddState(nodFind[0], strStateRefNo, strStateName);
                }
                nodFind = null;
            }
        }

        private void FunVoid_TreeViewAddState(TreeNode NodCountry, string strParamStateRefNo, string strParamStateName)
        {
            TreeNode nodState = new TreeNode();
            nodState.Name = strParamStateRefNo;
            nodState.Text = strParamStateName + " - " + strParamStateRefNo;
            nodState.Tag = strParamStateRefNo;
            nodState.ForeColor = System.Drawing.Color.Green;
            if (NodCountry != null)
            {
                NodCountry.Nodes.Add(nodState);
            }
        }
    }
}
